#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <intrinsics.h>


// --- CMSIS ---
typedef enum IRQn
{
  SysTick_IRQn = -1, 
  IRQ0 = 0, 
} IRQn_Type;
#define __CM0_REV  0
#define __NVIC_PRIO_BITS 2
#define __Vendor_SysTickConfig 0
#include <core_cm0.h>


#define Tms 2000
void timer (int ms) 
{
  for (volatile int i = i; i < ms; i++)
  {  
    for(volatile int j = 0; j < Tms; j++);
  }
}

void SysTick_Handler(void)
{
 static int cnt = 0;
 printf("Systic %5d\n", cnt++);
}

void IRQ0_Handler()
{
    printf("IRQ0 start\n");
    __enable_interrupt();
    timer(300);    
    printf("IRQ0 end\n");
}

void IRQ1_Handler()
{
  printf("SYSTIC > IRQ0\n");
  NVIC_SetPriority(IRQ0, 3);
  NVIC_SetPriority(SysTick_IRQn, 0);
}

void IRQ2_Handler()
{
  printf("SYSTIC < IRQ0\n");
  NVIC_SetPriority(IRQ0, 0);
  NVIC_SetPriority(SysTick_IRQn, 3);
}

void SystemInit(void)
{
  IRQ2_Handler(); 
}

void main()
{
  SystemInit();
  while(1) ;
}
